/* GETREF.H -- Constants and functions used by getref */

#ifndef GETREF_H
#define GETREF_H

#include <stdio.h>
#include "system.h"
#include "dbquery.h"
#include "loadfile.h"

#define  SZ_PARAM	255

#define  NOREF		0
#define  ALLREF		1
#define  ONEREF		2

#define	 MAXINST	15
#define  MAXMODE	15
#define  MAXKEYS	50
#define  MAXDETAIL	10

#define  STOP		0
#define  START		1

#define  FILE_TYPE	"science|wavecal"
#define  FIELD_TYPE	"switch|ref_file"
#define  KEYWORD_TYPE	"ref_file|switch|calibrat"

extern char * 	inst_cdbs[MAXINST];
extern char * 	inst_dads[MAXINST];
extern int	is_fits[MAXINST];
extern char * 	instrument[MAXINST];
extern char *	cdbsfile[MAXINST];
extern char *	cdbsrow[MAXINST];
extern char *	dadstab[MAXINST];
extern char *	obsfield[MAXINST];
extern char *	lockfield[MAXINST];
extern char *	detail_filecol[MAXDETAIL];
extern char *	detail_rowcol[MAXDETAIL];

extern void	best_files (context *, char *, char *, table *);
extern void	best_switches (context *, char *, table *);
extern void	build_fname (char *, char *, char *, int, char *, int);
extern int 	check_lock (context *, char *);
extern int	check_switch (char *);
extern void	clean_data (char *);
extern textbuf *expand_assoc (context *);
extern void 	free_assoc (textbuf *);
extern void 	free_files (textbuf *);
extern void	free_qryvars (char **);
extern int	get_icode_obs (char *);
extern int	get_icode_ref (char *);
extern int	get_keywords (context *, char *, char *, char *, 
			      char **, char **, char **, int);
extern table *	getref_all (void);
extern table *	getref_one (void);
extern int 	has_wavecal (context *, char *);
extern void 	html_log (const char *, ...);
extern int	is_reffile (char *);
extern int	is_wavefile (char *);
extern void	key_changes (context *, char *, table *);
extern int	needs_quotes (char *);
extern table *	qry_nomode (context *, char *, char *);
extern table *	qry_noroot (context *, char *, char **);
extern void	qry_obsmode (context *, char *, char **, int);
extern char *	mkanchor (char *, char *, char *, char *);
extern void	output_asc (table *);
extern void	output_html (char *, table *);
extern int	search_table (table *, char *, char *);
extern void 	set_calibrate (context *, char *, table *);
extern void	set_transact (context *, char *, int);
extern void	wav_switches (context *, char *, table *);
extern textbuf *which_files (context *, char *, char *, char *);
extern int	which_qry (void);
extern void	xtract_root (char *, char *, int);

#endif
